<?php
/**
 * Copyright © 2015 FiloBlu . All rights reserved.
 */
namespace FiloBlu\Flow\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper
{

       /**
        * @param \Magento\Framework\App\Helper\Context $context
        */
	public function __construct(\Magento\Framework\App\Helper\Context $context) {

		parent::__construct($context);

	}

	public function getModels() {

		$channels_in = (Array)$this->scopeConfig->getValue('processor/channels/in');
		$channels_out = (Array)$this->scopeConfig->getValue('processor/channels/out');

		$classes['select'] = '';

		foreach ($channels_in as $key=>$channel) {
			$classes[$channel] =  $key;
		}

		foreach ($channels_out as $key=>$channel) {
			$classes[$channel] =  $key;
		}

		return $classes;

	}

    public function getChannelModels($channel_input) {


		$channels_in = (Array)$this->scopeConfig->getValue('processor/channels/in');

		foreach ($channels_in as $key=>$channel) {
			if($channel == $channel_input) {
                return $key;
            }
		}

		return;

	}

	public function file_get_php_classes($filepath) {
		$php_code = file_get_contents($filepath);
		$classes = $this->get_php_classes($php_code);
		return $classes;
	}

	public function get_php_classes($php_code) {
		$classes = array();
		$tokens = token_get_all($php_code);
		$count = count($tokens);
		for ($i = 2; $i < $count; $i++) {
			if (   $tokens[$i - 2][0] == T_CLASS
				&& $tokens[$i - 1][0] == T_WHITESPACE
				&& $tokens[$i][0] == T_STRING) {

				$class_name = $tokens[$i][1];
				$key = $end = end(explode('_', $class_name));
				if ($key != 'Abstract')
					return $class_name;
			}
		}
		return array();
	}

	public function removeTextSpaces($text){
		$result = preg_replace("/\s/u", "", $text);
		$result = preg_replace("/( )+/u", "", $result);
		return trim($result);
	}

	public function getAllWebsitesIds(){
		$websitesIds = array();

		/** @var \Magento\Framework\App\ObjectManager $om */
		$om = \Magento\Framework\App\ObjectManager::getInstance();
		/** @var \Magento\Store\Model\StoreManagerInterface|\Magento\Store\Model\StoreManager $storeManager */
		$storeManager = $om->get('Magento\Store\Model\StoreManagerInterface');
		$storeManager->getStores($withDefault = true);

		foreach ($storeManager->getStores($withDefault = true) as $website) {
			$websitesIds[$website->getCode()] = $website->getId();
		}

		return $websitesIds;
	}


        public function getSkeleton()
        {

            return str_replace(array("\n",' '),'',
                '{"field":{"from":"","to":"","type":"text","validators":[],"filters":[],"stores":"","locale":"","actions":[]} }');

        }


}
