<?php

namespace FiloBlu\Flow\Model\From\Entity;

class Product extends AbstractEntity{

    public function getObjectId(){

        if(is_null($this->_objectEntityId)){
            $this->_objectEntityId = \Magento\Framework\App\ObjectManager::getInstance()->create($this->getEntityModel())->getIdBySku( $this->_entityIdentifier);
            if(empty($this->_objectEntityId)){
                $this->_objectEntityId = false;
            }
        }

        return $this->_objectEntityId;
    }

    protected function setObjectAttributeValue(){

        if(!$this->getObjectId()){
            $message = sprintf('No id found for model %s with given identifier %s',$this->getEntityModel(),$this->_entityIdentifier);
            throw new \Exception($message, FiloBlu_Flow_Model_From_Eavs::PRODUCT_NOT_FOUND_ERR_CODE);
        }

        $pids = array($this->getObjectId());

        $fatherProductsIds = $this->helper_product->getParentProductsIds($pids);

        if(!empty($fatherProductsIds)){
            //mettere in configurazione gli atributi da copiare sul configurabile
            //if(in_array($this->_attributeCode, $attributesToCopy)){
                $pids = array_merge($pids, $fatherProductsIds);
            //}
        }

        $input_type = strtolower($this->getAttribute()->getFrontend()->getInputType());
        $attributeValue = $this->getAttributeValue();

        if(($input_type === 'multiselect' || $input_type === 'select') && $this->_storeId!=0){//Mage_Core_Model_App::ADMIN_STORE_ID){
            //MAGE-440 Controllare che se l'attributo è un dropdown e viene passato uno scope non nullo lo metta a meta processed 1 senza fare nulla.
//            throw new \Exception('Select and multi select have to be set on store view 0 only',FiloBlu_Flow_Model_From_Eavs::DROPDOWN_STORE_ERR_CODE);
        }

        if($input_type === 'multiselect' && empty($attributeValue)){
            foreach($pids as $pid){
                $attributesData = array($this->getAttribute()->getAttributeCode() => $attributeValue);
                if($this->getAttribute()->getAttributeCode() != 'sku'){
                    \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                        ->updateAttributes($pids, $attributesData, $this->_storeId);
                    }
            }
        }else{
            $attributesData = array($this->getAttribute()->getAttributeCode() => $attributeValue);
            try{
                if($this->getAttribute()->getAttributeCode() != 'sku'){
                    \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                        ->updateAttributes($pids, $attributesData, $this->_storeId);

                }
            }catch (\Exception $e){
                $message = "Problem while processing eavs,<br/> store id : ".$this->_storeId."<br/> pids : ".print_r($pids,true). "<br/> attribute data : ".print_r($attributesData,true);
                $message .= "<br/> \Exception : ".$e->getMessage();
                $message .= "<br/> Backtrace : <br/> ".nl2br($e->getTraceAsString());
                FiloBlu_Flow_Model_From_Eavs::sendErrorEmail($message);
                throw new \Exception($e->getMessage());
            }
        }
    }

}//End of class
