<?php
namespace FiloBlu\Flow\Model\From;

class Price extends AbstractFrom {

    /**
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource $resource
     * @param \Magento\Framework\Data\Collection\Db $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Price $helper_price,
        \FiloBlu\Flow\Helper\Data $helper_flow,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Catalog\Model\ProductFactory $productFactory,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    )
    {
        $this->helper_price = $helper_price;
        $this->helper_flow = $helper_flow;
        $this->storeManager = $storeManager;
        $this->productFactory = $productFactory;
        $this->_logger = $context->getLogger();
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    /**
     * @return void
     */
    public function _construct()
    {
        $this->_init('FiloBlu\Flow\Model\ResourceModel\From\Price');
    }


    public function process() {

        $productSku = $this->getSku();
        $paese = $this->getPaese();
        $prezzo = $this->getPrezzo();
        $valuta = $this->getValuta();

        $allStore = $this->helper_flow->getAllWebsitesIds();

        if(is_null($paese)){
            $paese = 'admin';
        }
        $storeId = $allStore[$paese];

        $productId = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->getIdBySku($productSku);

        $product = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')
            ->setStoreId($storeId)
            ->load($productId)
            ->setPrice($prezzo)
            ->save();


        return $this;

    }


}